    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * NormalDistributionFunction2D.java
    029     * ---------------------------------
    030     * (C)opyright 2004-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 25-May-2004 : Version 1 (DG);
    038     * 21-Nov-2005 : Added getters for the mean and standard deviation (DG);
    039     *
    040     */
    041
    042    package org.jfree.data.function;
    043
    044    /**
    045     * A normal distribution function.
    046     */
    047    public class NormalDistributionFunction2D implements Function2D {
    048
    049        /** The mean. */
    050        private double mean;
    051
    052        /** The standard deviation. */
    053        private double std;
    054
    055        /**
    056         * Constructs a new normal distribution function.
    057         *
    058         * @param mean  the mean.
    059         * @param std  the standard deviation.
    060         */
    061        public NormalDistributionFunction2D(double mean, double std) {
    062            this.mean = mean;
    063            this.std = std;
    064        }
    065
    066        /**
    067         * Returns the mean for the function.
    068         *
    069         * @return The mean.
    070         */
    071        public double getMean() {
    072            return this.mean;
    073        }
    074
    075        /**
    076         * Returns the standard deviation for the function.
    077         *
    078         * @return The standard deviation.
    079         */
    080        public double getStandardDeviation() {
    081            return this.std;
    082        }
    083
    084        /**
    085         * Returns the function value.
    086         *
    087         * @param x  the x-value.
    088         *
    089         * @return The value.
    090         */
    091        public double getValue(double x) {
    092            return Math.exp(-1.0 * (x - this.mean) * (x - this.mean)
    093                    / (2 * this.std * this.std)) / Math.sqrt(2 * Math.PI
    094                    * this.std * this.std);
    095        }
    096
    097    }